//
//  ViewController.m
//  PDFScanner-Test
//
//  Created by VeryPDF on 2017/4/10.
//  Copyright © 2017 year VeryPDF. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    UIButton *myButton = [UIButton buttonWithType:UIButtonTypeSystem];
    int yourButtonWidth = 300;
    int yourButtonheight = 300;
    float X_Co = (self.view.frame.size.width - yourButtonWidth)/2;
    float Y_Co = (self.view.frame.size.height - yourButtonheight)/2;
    myButton.frame = CGRectMake(X_Co, Y_Co, yourButtonWidth, yourButtonheight);
    myButton.titleLabel.lineBreakMode = NSLineBreakByWordWrapping;
    myButton.titleLabel.textAlignment = NSTextAlignmentCenter;
    [myButton setTitle:@"Click me to test\nVeryPDF PDF Scanner for iOS" forState:UIControlStateNormal];
    [myButton addTarget:self action:@selector(didTouchUp:) forControlEvents:UIControlEventTouchUpInside];
    myButton.backgroundColor = [UIColor blueColor];
    [myButton setTitleColor:[UIColor redColor] forState:UIControlStateNormal ];
    [self.view addSubview:myButton];
}

// This method will be called when touch up is made on the button
- (void)didTouchUp:(UIButton *)sender
{
    NSLog(@"Button Pressed!");

    [self ScanTo_PDF_OR_Image_File:NO PageNumber:[self.arrayImageFilesForMakePDF count]];
    return;
}

- (NSString*) GetRootFolder
{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    if([paths count] <= 0)
    {
        return @"/";
    }
    return [paths objectAtIndex:0];
}

- (NSString*) GetCurrentFolder
{
    return [self GetRootFolder];
}

-(NSString*) MyGetNewFileName:(NSString*)oldFileName StartNumber:(int)nStartNumber PrefixZeroNumber:(int)nPrefixZeroNumber
{
    if(nPrefixZeroNumber <= 0)
    {
        if ([[NSFileManager defaultManager] fileExistsAtPath:oldFileName] == NO)
        {
            return oldFileName;
        }
    }
    
    if(nStartNumber <= 0)
        nStartNumber = 1;
    
    NSString *strSeparator = @".";
    for(int i = nStartNumber; i < 99999; i++)
    {
        NSString *pathWithNoFileName = [oldFileName stringByDeletingLastPathComponent];
        NSString *strShortFileName = [oldFileName lastPathComponent];
        strShortFileName = [strShortFileName stringByDeletingPathExtension];
        
        NSArray *stringArray = [strShortFileName componentsSeparatedByString: strSeparator];
        if([stringArray count] > 1)
            strShortFileName = [stringArray objectAtIndex:0];
        
        NSString* strFileNameNoExt = [pathWithNoFileName stringByAppendingPathComponent:strShortFileName];
        NSString* strExtension = [oldFileName pathExtension];
        
        NSString *strFromInt = [NSString stringWithFormat:@"%@%d", strSeparator, i];
        if(nPrefixZeroNumber > 0)
        {
            NSNumberFormatter * numberFormatter = [[NSNumberFormatter alloc] init];
            [numberFormatter setPaddingPosition:NSNumberFormatterPadBeforePrefix];
            [numberFormatter setPaddingCharacter:@"0"];
            [numberFormatter setMinimumIntegerDigits:nPrefixZeroNumber];
            NSNumber * number = [NSNumber numberWithInt:i];
            NSString * theString = [numberFormatter stringFromNumber:number];
            strFromInt = [NSString stringWithFormat:@"%@%@", strSeparator, theString];
        }
        
        NSString *strNewFileName = [strFileNameNoExt stringByAppendingString:strFromInt];
        if(strExtension.length > 0)
        {
            strNewFileName = [strNewFileName stringByAppendingPathExtension:strExtension];
        }
        if ([[NSFileManager defaultManager] fileExistsAtPath:strNewFileName] == NO)
        {
            return strNewFileName;
        }
    }
    return nil;
}

-(NSString*)GetNewFileNameAtCurrentFolder:(NSString*) strFileName Ext:(NSString*) strExt PrefixZeroNumber:(int)nPrefixZeroNumber
{
    NSString *strCurrentFolder = [self GetCurrentFolder];
    NSString *img_temp_name = [[NSString stringWithFormat:strFileName] stringByAppendingString:strExt];
    NSString *full_path=[strCurrentFolder stringByAppendingPathComponent:img_temp_name];
    NSString *strNewFileName = [self MyGetNewFileName:full_path StartNumber:1 PrefixZeroNumber:nPrefixZeroNumber];
    return strNewFileName;
}

- (void)imagePickerDidChooseImageWithPath:(NSString *)path
{
    NSLog(@"imagePickerDidChooseImageWithPath:%@", path);
    
    NSString *strDocumentFile = nil;
    NSError *error;
    if ([[NSFileManager defaultManager] fileExistsAtPath:path])
    {
        NSLog(@"File Found at %@", path);
        NSString *fileExtension = @".";
        fileExtension = [fileExtension stringByAppendingString:[path pathExtension]];
        strDocumentFile = [self GetNewFileNameAtCurrentFolder:@"scan" Ext:fileExtension PrefixZeroNumber:4];
        
        if ([[NSFileManager defaultManager] fileExistsAtPath:strDocumentFile] == NO)
        {
            [[NSFileManager defaultManager]  copyItemAtPath:path toPath:strDocumentFile error:&error];
        }
        NSLog(@"CopyFile: %@=>%@", path, strDocumentFile);
    }
    else
    {
        NSLog(@"No File Found at %@", path);
    }
    
    BOOL bOK = [[NSFileManager defaultManager] removeItemAtPath:path error:&error];
    NSLog(@"bOK=%d, error=%@", bOK, error);
    
    if(self.bMakePDF)
    {
        if(strDocumentFile != nil)
        {
            if(self.arrayImageFilesForMakePDF == nil)
                self.arrayImageFilesForMakePDF = [[NSMutableArray alloc] init];
            [self.arrayImageFilesForMakePDF addObject:strDocumentFile];
        }
        [self dismissViewControllerAnimated:NO completion:nil];
        [self ScanTo_PDF_OR_Image_File:NO PageNumber:[self.arrayImageFilesForMakePDF count]];
    }
    else
    {
        [self dismissViewControllerAnimated:YES completion:nil];
    }
}

-(BOOL)DeleteFile:(NSString*)strFile
{
    NSLog(@"Delete folder or file: %@", strFile);
    
    NSError *error;
    if (![[NSFileManager defaultManager] removeItemAtPath:strFile error:&error])	//Delete it
    {
        NSLog(@"Failed to delete folder or file: %@", error);
        return FALSE;
    }
    return TRUE;
}

-(void)ViewPDFFile:(NSString*)strPDFFile
{
    NSURL *URL = [NSURL fileURLWithPath:strPDFFile];

    if (URL)
    {
        // Initialize Document Interaction Controller
        self.documentInteractionController = [UIDocumentInteractionController interactionControllerWithURL:URL];
    
        // Configure Document Interaction Controller
        [self.documentInteractionController setDelegate:self];
    
        // Preview PDF
        [self.documentInteractionController presentPreviewAnimated:NO];
    }
}
- (UIViewController *) documentInteractionControllerViewControllerForPreview: (UIDocumentInteractionController *) controller
{
    return self;
}

-(NSString*)MakePDFFromImageFiles:(NSMutableArray*)arrayImageFiles
{
    if(self.arrayImageFilesForMakePDF == nil)
        return nil;
    if([self.arrayImageFilesForMakePDF count] <= 0)
        return nil;
    
    NSString *strPDFFile = [self GetNewFileNameAtCurrentFolder:@"document" Ext:@".pdf" PrefixZeroNumber:0];
    CGSize pageSize = CGSizeMake(612, 792);
    PDFScanner_MakePDFFromImageFiles(self.arrayImageFilesForMakePDF, strPDFFile, pageSize);
    
    [self.arrayImageFilesForMakePDF removeAllObjects];
    self.arrayImageFilesForMakePDF = nil;
    
    return strPDFFile;
}

- (void)imagePickerDidCancel
{
    NSLog(@"imagePickerDidCancel");
    
    NSString *strPDFFile = nil;
    if(self.arrayImageFilesForMakePDF != nil && [self.arrayImageFilesForMakePDF count] > 0)
    {
        for(int i = 0; i < [self.arrayImageFilesForMakePDF count]; i++)
        {
            NSString *strImageFile = [self.arrayImageFilesForMakePDF objectAtIndex:i];
            NSLog(@"File%d: %@", i+1, strImageFile);
        }
        
        strPDFFile = [self MakePDFFromImageFiles:self.arrayImageFilesForMakePDF];
        
        BOOL bDeleteSourceImageFiles = TRUE;
        if(bDeleteSourceImageFiles)
        {
            for(int i = 0; i < [self.arrayImageFilesForMakePDF count]; i++)
            {
                NSString *strImageFile = [self.arrayImageFilesForMakePDF objectAtIndex:i];
                [self DeleteFile:strImageFile];
            }
        }
    }
    
    [self dismissViewControllerAnimated:YES completion:nil];
    
    if(strPDFFile != nil)
        [self ViewPDFFile:strPDFFile];
}

-(void)ScanTo_PDF_OR_Image_File:(BOOL)animated PageNumber:(int)nPageNumber
{
    PDFScanner_SetLicenseCode("XXXX-XXXX-XXXX-XXXX");
    
    MAImagePickerController *imagePicker = [[MAImagePickerController alloc] init];
        
    self.bMakePDF = YES;
    imagePicker.nPageNumber = nPageNumber;
    [imagePicker setDelegate:self];
    [imagePicker setSourceType:MAImagePickerControllerSourceTypeCamera];
        
    UINavigationController *navigationController = [[UINavigationController alloc] initWithRootViewController:imagePicker];
    
    dispatch_async(dispatch_get_main_queue(), ^ {
        [self presentViewController:navigationController animated:animated completion:nil];
    });
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
